> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/bmc/bare-metal-instance/describeavailableresources.md).

# DescribeAvailableResources

## 1. API Description

This API (DescribeAvailableResources) is used to describe the status of available resources.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name     | Required | Type                                                                 | Description                                                                                                                                |
| ------------------ | -------- | -------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------ |
| instanceChargeType | Yes      | [ChargeType](/api-reference/compute/bmc/datastructure.md#chargetype) | <p>Instance pricing model .</p><p>PREPAID: subscription</p><p>POSTPAID: pay-as-you-go</p>                                                  |
| instanceTypeId     | No       | String                                                               | Instance model ID.                                                                                                                         |
| zoneId             | No       | String                                                               | Zone ID.                                                                                                                                   |
| sellStatus         | No       | [SellStatus](/api-reference/compute/bmc/datastructure.md#sellstatus) | <p>Status of sale.</p><p>SELL : available for sale, stock > 10. SELL\_SHORTAGE : available for sale, stock < 10. SOLD\_OUT : sold out.</p> |

## 3. Output Parameters

| Parameter Name     | Type                                                                                        | Description                                                                                                           |
| ------------------ | ------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId          | String                                                                                      | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| availableResources | Array of [AvailableResource](/api-reference/compute/bmc/datastructure.md#availableresource) | Information on available resources, including zoneId, status, quantity, etc.                                          |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query available resources**

```json
POST / HTTP/1.1
Host: console.zenlayer.com/api/v2/bmc
Content-Type: application/json
X-ZC-Action: DescribeAvailableResources
<Common Request Params>

Request:
{
  "instanceTypeId": "MDE",
  "instanceChargeType": "PREPAID",
  "zoneId": "MOW-B"
}

Response:
{
  "requestId": "T001A67B7-C345-4B0E-A9B0-FB0C859C9075",
  "response": {
    "requestId": "T001A67B7-C345-4B0E-A9B0-FB0C859C9075",
    "availableResources": [
      {
        "zoneId": "MOW-B",
        "status": "SELL",
        "internetChargeTypes": [
          "ByBandwidth",
          "ByTrafficPackage"
        ],
        "instanceTypeId": "MDE",
        "maximumBandwidthOut": 10000,
        "defaultBandwidthOut": 50,
        "defaultTrafficPackageSize": 5.0
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                          | Description                                                       |
| ---------------- | ----------------------------------- | ----------------------------------------------------------------- |
| 403              | INVALID\_CHARGE\_TYPE\_NOT\_SUPPORT | The current account does not support the specified pricing model. |
| 404              | INVALID\_ZONE\_NOT\_FOUND           | Zone not found.                                                   |
